#!/usr/bin/perl -I/usr/sausalito/perl
# 
# Name: detectportscans.pl
# Author: Jesse Throwe
# Description: This script parses a phoenix.log file (heavily borrowed from sam)
# and reports the ips currently blocked.
# Copyright 2001 Sun Microsystems, Inc. All rights reserved.
# $Id: detectportscans.pl,v 1.3 2001/10/15 19:03:50 jthrowe Exp $

##################
## Variables

$logfile = "/var/log/phoenix.log";
$timeout = 300;


# we need to find out if scandetection actually isfirewallying.. so we use cce

# initalize CCE
use CCE;

my $cce = new CCE;
$cce->connectuds();

# find our system OID
my @system_oid = $cce->find("System");


# get the Scandetection object
my ($ok, $object, $old, $new) = $cce->get($system_oid[0], 'Scandetection');

# check to make sure CCE/Scandetection object is ok, leave if not
if (!$ok) {
        exit(0);
}

#acquire our variable
my ($paranoiaLevel) = $cce->scalar_to_array($object->{paranoiaLevel});

# and test
if ($paranoiaLevel < 2) { exit 0; }

# now lets actually do the search, sense we are sure we are firewalling

## first lets get the time

($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time - $timeout);

# because month is 0-11, we have to add 1
$mon++;

# becauase we are in the year 2k problem lies
$year = $year - 100;

# more year managling. we have to add a 0 if year is less than 10
if ($year < 10) {
$year = "0$year";
}

# add a 0 to the hour, minute, and second fields if it is less than 10
if ($hour < 10) {
$hour = "0$hour";
}

if ($min < 10) {
$min = "0$min";
}

if ($sec < 10) {
$sec = "0$sec";
}

# now mash them all together
$ourtime = "$year$mon$mday$hour$min$sec";

# open the log
open (LOGFILE, $logfile) or die "unable to open $logfile";

while (<LOGFILE>) {
	
	@entry = split;
	
	# get the log time in plain format
	$logfiletime = $entry[0];
	@localdatetime = split(/-/, $logfiletime);
	@datesplit = split(/\//, $localdatetime[0]);
	@timesplit = split(/:/, $localdatetime[1]);
	$logfiletime = "$datesplit[2]$datesplit[0]$datesplit[1]$timesplit[0]$timesplit[1]$timesplit[2]";
	
	# if the logtime is less than the timeout, further examination is needed
	if ($logfiletime > $ourtime) {
		($iface, $loggingtype, $rest) = split (":", $entry[1]);
		$iface =~ s/[0-9]//;
		if ($iface ne "eth") {
			$blockedips = "";
		} elsif ($entry[2] eq "Firewall") {
			$blockedips = "";
		} elsif ($loggingtype eq "portscan"){	
			($blockedip, $rest) = split ("/", $entry[5]);
			$blockedips = "$blockedips$blockedip\n";
		}
	}
}

close LOGFILE;

print $blockedips;
